/*
 * scb.c
 *
 *  Created on: Aug 9, 2013
 *      Author: AAgarwal2
 */

#include "SCB_Optimization_Core0.h"

// Configure block on SCB4
int scb_init(void)
{

#ifdef DEBUG
	int varSI;

#if TEST_CASE == 1
	printf("Default Configuration: 2 slots each for DMA 21-28 channel \n");
#endif
#endif

#if TEST_CASE == 2 || TEST_CASE == 3

#ifdef DEBUG
	printf("\nAssigning additional 1 set of Slots for DMA channel 21-22 channel \n");
	// Read the SI assigned at Slot No 6 of SCB4  which is DMA27
	*pREG_SCB4_ARBR0 = 0xFF000006;
	varSI = *pREG_SCB4_ARBR0;
	printf("Default Slave Interface assigned to slot No 6 on SCB4 %d\n", varSI);

	// Read the SI assigned at Slot No 7 of SCB4  which is DMA28
	*pREG_SCB4_ARBW0 = 0xFF000007;
	varSI = *pREG_SCB4_ARBW0;
	printf("Default Slave Interface assigned to slot No 7 on SCB4 %d \n", varSI);

	printf("\nAssigning Slots 6 and 7 on SCB4 to DMA21 & DMA22\n ");
#endif
	// Assign SI - DMA21 to Slot No 6 on read channel SCB4
	*pREG_SCB4_ARBR0 = 0x06000000;

	// Assign SI - DMA22 to Slot No 7 on write channel SCB4
	*pREG_SCB4_ARBW0 = 0x07000001;

#ifdef DEBUG
	// Read the SI assigned at Slot No 6 of SCB4  which is DMA27
	*pREG_SCB4_ARBR0 = 0xFF000006;
	varSI = *pREG_SCB4_ARBR0;
	printf("Slave Interface assigned on slot No 6 on SCB4 %d \n", varSI);

	// Read the SI assigned at Slot No 6 of SCB4  which is DMA27
	*pREG_SCB4_ARBW0 = 0xFF000007;
	varSI = *pREG_SCB4_ARBW0;
	printf("Slave Interface assigned on slot No 7 on SCB4 %d \n", varSI);

#endif
#endif

#if TEST_CASE == 3

#ifdef DEBUG
	printf("\n\nAssigning additional 2 set of Slots for DMA channel 21-22 channel \n");
	// Read the SI assigned at Slot No 14 of SCB4  which is DMA27
	*pREG_SCB4_ARBR0 = 0xFF00000E;
	varSI = *pREG_SCB4_ARBR0;
	printf("Default Slave Interface assigned to slot No 14 on SCB4 %d\n", varSI);

	// Read the SI assigned at Slot No 6 of SCB4  which is DMA28
	*pREG_SCB4_ARBW0 = 0xFF00000F;
	varSI = *pREG_SCB4_ARBW0;
	printf("Default Slave Interface assigned to slot No 15 on SCB4 %d\n", varSI);

	printf("\nAssigning Slots 14 and 15 on SCB4 to DMA21 & DMA22\n");
#endif
	// Assign SI - DMA21 to Slot No 14 on read channel SCB4
	*pREG_SCB4_ARBR0 = 0x0E000000;

	// Assign SI - DMA22 to Slot No 15 on write channel SCB4
	*pREG_SCB4_ARBW0 = 0x0F000001;

#ifdef DEBUG
	// Read the SI assigned at Slot No 14 of SCB4  which is DMA27
	*pREG_SCB4_ARBR0 = 0xFF00000E;
	varSI = *pREG_SCB4_ARBR0;
	printf("Slave Interface assigned on slot No 14 on SCB4 %d\n", varSI);

	// Read the SI assigned at Slot No 15 of SCB4  which is DMA28
	*pREG_SCB4_ARBW0 = 0xFF00000F;
	varSI = *pREG_SCB4_ARBW0;
	printf("Slave Interface assigned on slot No 15 on SCB4 %d\n\n", varSI);
#endif

#endif
	return 0;

}
